unit Unit3;

interface

uses
  UnitZpracovaniZdrojovehoKodu, Classes {$IFDEF MSWINDOWS} , Windows {$ENDIF};

type
  Vlakno = class(TThread)
  private
    vlak: ZpracovaniZdrojovehoKodu;
    procedure SetName;
  protected
    procedure Execute; override;
  public
    constructor Create (vl: ZpracovaniZdrojovehoKodu);
  end;

implementation

constructor Vlakno.Create (vl: ZpracovaniZdrojovehoKodu);
begin
    inherited Create (false);
    vlak := vl;
    FreeOnTerminate := true;
end;


{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure Vlakno.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{$IFDEF MSWINDOWS}
type
  TThreadNameInfo = record
    FType: LongWord;     // must be 0x1000
    FName: PChar;        // pointer to name (in user address space)
    FThreadID: LongWord; // thread ID (-1 indicates caller thread)
    FFlags: LongWord;    // reserved for future use, must be zero
  end;
{$ENDIF}

{ Vlakno }

procedure Vlakno.SetName;
{$IFDEF MSWINDOWS}
var
  ThreadNameInfo: TThreadNameInfo;
{$ENDIF}
begin
{$IFDEF MSWINDOWS}
  ThreadNameInfo.FType := $1000;
  ThreadNameInfo.FName := 'VlaknoVykonavani';
  ThreadNameInfo.FThreadID := $FFFFFFFF;
  ThreadNameInfo.FFlags := 0;

  try
    RaiseException( $406D1388, 0, sizeof(ThreadNameInfo) div sizeof(LongWord), @ThreadNameInfo );
  except
  end;
{$ENDIF}
end;

procedure Vlakno.Execute;
begin
  SetName;
  vlak.Execute;
end;

end.
 