unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Unit2, ExtCtrls;

type

  Stav = record
        x, y: real;
        fi: real;
        peroDole: boolean;
        kreslitZelvicku: boolean;
  end;

  TZImage = class(TForm)
  private
    aktStav: Stav;
    BM: TBitmap;
    {procedure vymazat;
    procedure kresli;
    procedure vpred (d: real);
    procedure otoc (x: real);
    procedure zvedniPero;
    procedure polozPero;
    procedure kresliZelvicku;
    procedure nekresliZelvicku;   }
  public
    constructor Create (owner: TComponent); override;
  end;

const PI = 3.14159;

implementation

{

procedure TForm1.kresliZelvicku;
begin
    aktStav.kreslitZelvicku := true;
    kresli;
end;


procedure TForm1.nekresliZelvicku;
begin
    aktStav.kreslitZelvicku := false;
    kresli;
end;


procedure TForm1.zvedniPero;
begin
    aktStav.peroDole := false;
end;


procedure TForm1.polozPero;
begin
    aktStav.peroDole := true;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
    inc (pocet);
    okenka[pocet] := TForm2.Create(Self);
    okenka[pocet].Show;
    ListBox1.Items.Add (IntToStr (pocet));
end;


procedure TForm1.vpred (d: real);
begin
    BM.Canvas.MoveTo (round (aktStav.x), round (aktStav.y));
    aktStav.x := aktStav.x + d*cos (aktStav.fi);
    aktStav.y := aktStav.y + d*sin (aktStav.fi);
    if aktStav.peroDole then
        BM.Canvas.LineTo (round (aktStav.x), round (aktStav.y));
    kresli;
end;


procedure TForm1.otoc (x: real);
begin
    aktStav.fi := aktStav.fi + x;
    kresli;
end;


procedure TForm1.kresli;
var rohy: array[1..3] of TPoint;
const ROZPETI = PI / 5;
const RAMENO = 20;
begin
    Image1.Canvas.Draw (0, 0, BM);
    if aktStav.kreslitZelvicku then begin
        rohy[1].X := round (aktStav.x);
        rohy[1].Y := round (aktStav.y);
        rohy[2].X := round (RAMENO*cos (aktStav.fi + ROZPETI / 2 + PI) + aktStav.x);
        rohy[2].Y := round (RAMENO*sin (aktStav.fi + ROZPETI / 2 + PI) + aktStav.y);
        rohy[3].X := round (RAMENO*cos (aktStav.fi - ROZPETI / 2 + PI) + aktStav.x);
        rohy[3].Y := round (RAMENO*sin (aktStav.fi - ROZPETI / 2 + PI) + aktStav.y);
        Image1.Canvas.Brush.Color := clNavy;
        Image1.Canvas.Polygon (rohy);
    end;
    Image1.Repaint;
end;

}
constructor TZImage.Create (owner: TComponent);
const INITPOZICE = 30;
begin
    TImage.Create (owner);
    with aktStav do begin
        x := Width / 2;
        y := Height - INITPOZICE;
        fi := -PI / 2;
        peroDole := true;
        kreslitZelvicku := true;
    end;
    BM := TBitmap.Create;
    BM.Height := Height;
    BM.Width := Width;
    {vymazat;}
end;
 {
procedure TForm1.ListBox1Click(Sender: TObject);
begin
    okenka[ListBox1.ItemIndex + 1].Show;
end;


procedure TForm1.vymazat;
begin
    BM.Canvas.Rectangle (0, 0, Width, Height);
    kresli;
end;


procedure TForm1.Button2Click(Sender: TObject);
const R = 15;
var i: integer;
begin
    nekresliZelvicku;
    zvedniPero;
    vpred (R);
    otoc (PI / 2);
    polozPero;
    for i := 1 to round (2 * PI * R) do begin
        vpred (1);
        otoc (1 / R);
    end;
    zvedniPero;
    otoc (PI / 2);
    vpred (R);
    otoc (PI);
    polozPero;
    kresliZelvicku;
end;
 }
end.
 